// CONTROLS
//
//
object_event_add(PlayerControl, ev_create, 0, '
	with(global.myself) {
		carryEnable	= carriers.carryEnable;
	}
');
object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if(not variable_local_exists("global.myself.carryEnable")) {
		with(global.myself) {
			carryEnable	= carriers.carryEnable;
		}
	}
');
object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if(global.myself.object != -1)
	if(not instance_exists(InGameMenuController))
	with(carriers) {
		if(keyboard_check_pressed(grabKey)) {
			var grabbedPlayer;
			// GRAB/RELEASE AS HOST
			if(global.isHost) {
				if((global.myself.object.carrier == noone)
					and (global.myself.object.carry == noone))
				{
					grabbedPlayer = execute_string(getCarryable, global.myself);
					if(grabbedPlayer != noone) {
						execute_string(sendGrab, global.myself, grabbedPlayer, NetworkController.sendBuffer);
						execute_string(doGrab, global.myself, grabbedPlayer);
					}
				} else {
					execute_string(sendRelease, global.myself, NetworkController.sendBuffer);
					execute_string(doRelease, global.myself, NetworkController.sendBuffer);
				}
			// GRAB/RELEASE AS CLIENT
			} else {
				if((global.myself.object.carrier == noone)
					and (global.myself.object.carry == noone))
				{
					write_ubyte(NetworkController.sendBuffer, GRAB);
				} else {
					write_ubyte(NetworkController.sendBuffer, RELEASE);
				}
			}
		}
		if(keyboard_check_pressed(modeKey)) {
			// MODE AS HOST
			if(global.isHost) {
				// switch and notify clients
				global.myself.object.carryRunning = !global.myself.object.carryRunning;
				if(global.myself.object.carryRunning) {
					execute_string(sendByteFrom, MODE_RUN, global.myself, NetworkController.sendBuffer);
				} else {
					execute_string(sendByteFrom, MODE_SHOOT, global.myself, NetworkController.sendBuffer);
				}
			// MODE AS CLIENT
			} else {
				// ask for switch
				if(global.myself.object.carryRunning) {
					write_ubyte(NetworkController.sendBuffer, MODE_SHOOT);
				} else {
					write_ubyte(NetworkController.sendBuffer, MODE_RUN);
				}
			}
		}
	}
');